package core;

import org.lwjgl.LWJGLException;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import static org.lwjgl.input.Keyboard.*;
import static org.lwjgl.opengl.GL11.*;
 
public class GameWindow {
 
	public int x;
	public int y;
	public int height = 800;
	public int width = 600;
    public void start() {
        try {
	    Display.setDisplayMode(new DisplayMode(height,width));
	    Display.create();
	} catch (LWJGLException e) {
	    e.printStackTrace();
	    System.exit(0);
	}
 
	// init OpenGL
	initGL();
 
	while (!Display.isCloseRequested()) {
	    // Clear the screen and depth buffer
		renderGL();
		handleGL();
	    Display.update();
	}
 
	Display.destroy();
    }
    
    public void renderGL() {
	    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	
		
	    // set the color of the quad (R,G,B,A)
	    glColor3f(0.5f,0.5f,1.0f);
	    	
	    // draw quad
	    glBegin(GL_QUADS);
	        glVertex2f(x,y);
		glVertex2f(x+50,y);
		glVertex2f(x+50,y+100);
		glVertex2f(x,y+100);
	    glEnd();
 
    }
    
    public void handleGL() {
    	if(isKeyDown(KEY_A)) x -= 1;
    	if(isKeyDown(KEY_D)) x += 1;
    	if(isKeyDown(KEY_W)) y += 1;
    	if(isKeyDown(KEY_S)) y -= 1;
    }
    
    public void initGL() {
    	glMatrixMode(GL_PROJECTION);
    	glLoadIdentity();
    	glOrtho(0, height, 0, width, 1, -1);
    	glMatrixMode(GL_MODELVIEW);
    }
 
    public static void main(String[] argv) {
        GameWindow game = new GameWindow();
        game.start();
    }
}