package core;

public class Material {

	public static final Material grass;
	public static final Material dirt;
	public static final Material stone;
	public static final Material wood;
	public static final Material glass;
	public static final Material explosive;
	public static final Material nullled;
	public static final Material sand;
	public static final Material gravel;
	public static final Material metal;
	public static final Material cloth;
	public static final Material leaves;
	public static final Material water;
	public static final Material lava;
	public static final Material air;
	public static final Material bottomstone;
	public boolean canDestroy;
	public boolean canHarvest;
	public boolean isTransparent;
	public boolean canBurn;
	
	
	public Material() {
		canDestroy = true;
	}
	
	public boolean isLiquid() {
		return false;
	}
	public boolean isSolid() {
		return true;
	}
	public boolean canBlockGrowth() {
		return true;
	}
	public boolean getBurnable() {
		return canBurn;
	}
	
	public boolean getTransparent() {
		return isTransparent;
	}
	public boolean getCanDestroy() {
		return canDestroy;
	}
	public boolean getCanHarvest () {
		return canHarvest;
	}
	public Material setTransparent() {
		isTransparent = true;
		return this;
	}
	public Material setNoDestroy() {
		canDestroy = false;
		return this;
	}
	
	public Material setNoHarvest() {
		canHarvest = false;
		return this;
	}
	public Material setBurnable() {
		canBurn = true;
		return this;
	}
	
	static {
		grass = new Material();
		dirt = new Material();
		stone = new Material().setNoHarvest();
		wood = new Material().setBurnable();
		glass = new Material().setTransparent();
		explosive = new Material().setBurnable();
		nullled = new Material().setNoDestroy().setTransparent();
		sand = new Material();
		gravel = new Material();
		metal = new Material().setNoHarvest();
		cloth = new Material().setBurnable();
		leaves = new Material().setBurnable().setNoHarvest().setTransparent();
		water = new MatLiquid();
		lava = new MatLiquid();
		air = new MatAir();
		bottomstone = new Material().setNoDestroy();
	}
}
