package tags;

import java.io.*;
import java.util.*;



public class ITHead extends ITBase {
	
	public Map mapTag;
	
	public ITHead () {
		super("");
		mapTag = new HashMap();
	}
	
	public ITHead (String name) {
		super(name);
		mapTag = new HashMap();
	}
	

	
	void writeToTag(DataOutput dataoutput) throws IOException {
		ITBase itbase;
		
		for(Iterator iterator = mapTag.values().iterator();
		iterator.hasNext(); ITBase.writeTag(itbase, dataoutput)) {
			itbase = (ITBase)iterator.next();
		}
		dataoutput.writeByte(0);
	}

	
	void readFromTag(DataInput datainput) throws IOException {
		mapTag.clear();
		ITBase itbase;
		for (; (itbase = ITBase.readTag(datainput)).getType() != 0; mapTag.put(itbase.getKey(), itbase)) {}
		
	}

	
	public byte getType() {
		return 1;
	}
	
	public Collection getTags() {
		return mapTag.values();
	}
	
	public void setTag(String name, ITBase itbase)
    {
        mapTag.put(name, itbase.setKey(name));
    }
	public void setByte(String name, byte inbyte) {
		mapTag.put(name, new ITByte(name, inbyte));
	}
	public void setByteArray(String name, byte[] inbytearr) {
		mapTag.put(name, new ITByteArray(name, inbytearr));
	}
	public void setDouble(String name, double indouble) {
		mapTag.put(name, new ITDouble(name, indouble));
	}
	public void setFloat(String name, float infloat) {
		mapTag.put(name, new ITFloat(name, infloat));
	}
	public void setHead(String name, ITHead ithead) {
		mapTag.put(name, ithead.setKey(name));
	}
	public void setInt(String name, int inint) {
		mapTag.put(name, new ITInt(name, inint));
	}
	public void setLong(String name, long inlong) {
		mapTag.put(name, new ITLong(name, inlong));
	}
	public void setShort(String name, short inshort) {
		mapTag.put(name, new ITShort(name, inshort));
	}
	public void setString(String name, String value) {
		mapTag.put(name, new ITString(name, value));
	}
	public void setBoolean(String name, boolean flag) {
		setByte(name,  ((byte)(flag ? 1 : 0)));
	}
	public ITBase getTag(String name) {
		return (ITBase)mapTag.get(name);
	}
	public boolean containsKey(String name) {
		return mapTag.containsKey(name);
	}
	
	public byte readByte(String name) {
		if(!mapTag.containsKey(name)) {
			return 0;
		}
		else {
			return ((ITByte)mapTag.get(name)).value;
		}
	}
	
	public short readShort(String name) {
		if(!mapTag.containsKey(name)) {
			return 0;
		}
		else {
			return ((ITShort)mapTag.get(name)).value;
		}
	}
	public int readInt(String name) {
		if(!mapTag.containsKey(name)) {
			return 0;
		}
		else {
			return ((ITInt)mapTag.get(name)).value;
		}
	}
	public long readLong(String name) {
		if(!mapTag.containsKey(name)) {
			return 0;
		}
		else {
			return ((ITLong)mapTag.get(name)).value;
		}
	}
	public double readDouble(String name) {
		if(!mapTag.containsKey(name)) {
			return 0;
		}
		else {
			return ((ITDouble)mapTag.get(name)).value;
		}
	}
	public float readFloat(String name) {
		if(!mapTag.containsKey(name)) {
			return 0;
		}
		else {
			return ((ITFloat)mapTag.get(name)).value;
		}
	}
	public String readString(String name) {
		if(!mapTag.containsKey(name)) {
			return "";
		}
		else {
			return ((ITString)mapTag.get(name)).value;
		}
	}
	public byte[] readBA(String name) {
		if(!mapTag.containsKey(name)) {
			return new byte[0];
		}
		else {
			return ((ITByteArray)mapTag.get(name)).value;
		}
	}
	public ITHead readHead(String name) {
		if(!mapTag.containsKey(name)) {
			return new ITHead(name);
		}
		else {
			return (ITHead)mapTag.get(name);
		}
	}
	public ITList readList(String name) {
		if(!mapTag.containsKey(name)) {
			return new ITList(name);
		}
		else {
			return (ITList)mapTag.get(name);
		}
	}
	public boolean readBoolean(String name) {
		return readByte(name) != 0;
	}
}



